﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Net;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using Syncfusion.JavaScript;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using MvcApplication66.Models;
using System.Threading;
using System.Reflection.Emit;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public static DataManager query = new DataManager();
        public ActionResult Index()
        {
            ViewBag.datasource1 = new NorthwindDataContext().EmployeeViews.ToList();
            return View();
        }
        public ActionResult DataSource(DataManager dm) {
            //save the query for exporing purpose
            query = dm;
            IEnumerable data = OrderRepository.GetAllRecords().ToList();
            DataOperations dp = new DataOperations();
            //filter the records based on the DataManager dm query and return
            data = dp.PerformWhereFilter(data, dm.Where, dm.Where[0].Condition);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            DataOperations dp = new DataOperations();
            //use the public query to filter the data
            DataSource = dp.PerformWhereFilter(DataSource, query.Where, query.Where[0].Condition);
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }
        public void ExportToWord(string GridModel)
        {
            WordExport exp = new WordExport();
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            DataOperations dp = new DataOperations();
            DataSource = dp.PerformWhereFilter(DataSource, query.Where, query.Where[0].Condition);
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        }
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            DataOperations dp = new DataOperations();
            DataSource = dp.PerformWhereFilter(DataSource, query.Where, query.Where[0].Condition);
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }
        public ActionResult TypeBuilder()
        {
           
            return View();
        }

    }
}